git.txt: fix list continuation
[git.git] / git-submodule.sh
blob7f6b3cf207ae51be30fc677cb8810ffb20cc9433
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-parse-remote
18 require_work_tree
20 command=
21 branch=
22 force=
23 reference=
24 cached=
25 recursive=
26 init=
27 files=
28 nofetch=
29 update=
30 prefix=
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
38 url="$1"
39 remoteurl=${remoteurl%/}
40 sep=/
41 while test -n "$url"
43 case "$url" in
44 ../*)
45 url="${url#../}"
46 case "$remoteurl" in
47 */*)
48 remoteurl="${remoteurl%/*}"
50 *:*)
51 remoteurl="${remoteurl%:*}"
52 sep=:
55 die "cannot strip one component off url '$remoteurl'"
57 esac
59 ./*)
60 url="${url#./}"
63 break;;
64 esac
65 done
66 echo "$remoteurl$sep${url%/}"
70 # Get submodule info for registered submodules
71 # $@ = path to limit submodule list
73 module_list()
75 git ls-files --error-unmatch --stage -- "$@" |
76 perl -e '
77 my %unmerged = ();
78 my ($null_sha1) = ("0" x 40);
79 while (<STDIN>) {
80 chomp;
81 my ($mode, $sha1, $stage, $path) =
82 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
83 next unless $mode eq "160000";
84 if ($stage ne "0") {
85 if (!$unmerged{$path}++) {
86 print "$mode $null_sha1 U\t$path\n";
88 next;
90 print "$_\n";
96 # Map submodule path to submodule name
98 # $1 = path
100 module_name()
102 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
103 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
104 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
105 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
106 test -z "$name" &&
107 die "No submodule mapping found in .gitmodules for path '$path'"
108 echo "$name"
112 # Clone a submodule
114 # Prior to calling, cmd_update checks that a possibly existing
115 # path is not a git repository.
116 # Likewise, cmd_add checks that path does not exist at all,
117 # since it is the location of a new submodule.
119 module_clone()
121 path=$1
122 url=$2
123 reference="$3"
125 if test -n "$reference"
126 then
127 git-clone "$reference" -n "$url" "$path"
128 else
129 git-clone -n "$url" "$path"
130 fi ||
131 die "Clone of '$url' into submodule path '$path' failed"
135 # Add a new submodule to the working tree, .gitmodules and the index
137 # $@ = repo path
139 # optional branch is stored in global branch variable
141 cmd_add()
143 # parse $args after "submodule ... add".
144 while test $# -ne 0
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
152 -f | --force)
153 force=$1
155 -q|--quiet)
156 GIT_QUIET=1
158 --reference)
159 case "$2" in '') usage ;; esac
160 reference="--reference=$2"
161 shift
163 --reference=*)
164 reference="$1"
165 shift
168 shift
169 break
172 usage
175 break
177 esac
178 shift
179 done
181 repo=$1
182 path=$2
184 if test -z "$path"; then
185 path=$(echo "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
189 if test -z "$repo" -o -z "$path"; then
190 usage
193 # assure repo is absolute or relative to parent
194 case "$repo" in
195 ./*|../*)
196 # dereference source url relative to parent's url
197 realrepo=$(resolve_relative_url "$repo") || exit
199 *:*|/*)
200 # absolute url
201 realrepo=$repo
204 die "repo URL: '$repo' must be absolute or begin with ./|../"
206 esac
208 # normalize path:
209 # multiple //; leading ./; /./; /../; trailing /
210 path=$(printf '%s/\n' "$path" |
211 sed -e '
212 s|//*|/|g
213 s|^\(\./\)*||
214 s|/\./|/|g
215 :start
216 s|\([^/]*\)/\.\./||
217 tstart
218 s|/*$||
220 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
221 die "'$path' already exists in the index"
223 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
224 then
225 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
226 echo >&2 $path &&
227 echo >&2 "Use -f if you really want to add it."
228 exit 1
231 # perhaps the path exists and is already a git repo, else clone it
232 if test -e "$path"
233 then
234 if test -d "$path"/.git -o -f "$path"/.git
235 then
236 echo "Adding existing repo at '$path' to the index"
237 else
238 die "'$path' already exists and is not a valid git repo"
241 case "$repo" in
242 ./*|../*)
243 url=$(resolve_relative_url "$repo") || exit
246 url="$repo"
248 esac
249 git config submodule."$path".url "$url"
250 else
252 module_clone "$path" "$realrepo" "$reference" || exit
254 clear_local_git_env
255 cd "$path" &&
256 # ash fails to wordsplit ${branch:+-b "$branch"...}
257 case "$branch" in
258 '') git checkout -f -q ;;
259 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
260 esac
261 ) || die "Unable to checkout submodule '$path'"
264 git add $force "$path" ||
265 die "Failed to add submodule '$path'"
267 git config -f .gitmodules submodule."$path".path "$path" &&
268 git config -f .gitmodules submodule."$path".url "$repo" &&
269 git add --force .gitmodules ||
270 die "Failed to register submodule '$path'"
274 # Execute an arbitrary command sequence in each checked out
275 # submodule
277 # $@ = command to execute
279 cmd_foreach()
281 # parse $args after "submodule ... foreach".
282 while test $# -ne 0
284 case "$1" in
285 -q|--quiet)
286 GIT_QUIET=1
288 --recursive)
289 recursive=1
292 usage
295 break
297 esac
298 shift
299 done
301 toplevel=$(pwd)
303 module_list |
304 while read mode sha1 stage path
306 if test -e "$path"/.git
307 then
308 say "Entering '$prefix$path'"
309 name=$(module_name "$path")
311 prefix="$prefix$path/"
312 clear_local_git_env
313 cd "$path" &&
314 eval "$@" &&
315 if test -n "$recursive"
316 then
317 cmd_foreach "--recursive" "$@"
319 ) ||
320 die "Stopping at '$path'; script returned non-zero status."
322 done
326 # Register submodules in .git/config
328 # $@ = requested paths (default to all)
330 cmd_init()
332 # parse $args after "submodule ... init".
333 while test $# -ne 0
335 case "$1" in
336 -q|--quiet)
337 GIT_QUIET=1
340 shift
341 break
344 usage
347 break
349 esac
350 shift
351 done
353 module_list "$@" |
354 while read mode sha1 stage path
356 # Skip already registered paths
357 name=$(module_name "$path") || exit
358 url=$(git config submodule."$name".url)
359 test -z "$url" || continue
361 url=$(git config -f .gitmodules submodule."$name".url)
362 test -z "$url" &&
363 die "No url found for submodule path '$path' in .gitmodules"
365 # Possibly a url relative to parent
366 case "$url" in
367 ./*|../*)
368 url=$(resolve_relative_url "$url") || exit
370 esac
372 git config submodule."$name".url "$url" ||
373 die "Failed to register url for submodule path '$path'"
375 upd="$(git config -f .gitmodules submodule."$name".update)"
376 test -z "$upd" ||
377 git config submodule."$name".update "$upd" ||
378 die "Failed to register update mode for submodule path '$path'"
380 say "Submodule '$name' ($url) registered for path '$path'"
381 done
385 # Update each submodule path to correct revision, using clone and checkout as needed
387 # $@ = requested paths (default to all)
389 cmd_update()
391 # parse $args after "submodule ... update".
392 orig_flags=
393 while test $# -ne 0
395 case "$1" in
396 -q|--quiet)
397 GIT_QUIET=1
399 -i|--init)
400 init=1
402 -N|--no-fetch)
403 nofetch=1
405 -r|--rebase)
406 update="rebase"
408 --reference)
409 case "$2" in '') usage ;; esac
410 reference="--reference=$2"
411 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
412 shift
414 --reference=*)
415 reference="$1"
417 -m|--merge)
418 update="merge"
420 --recursive)
421 recursive=1
424 shift
425 break
428 usage
431 break
433 esac
434 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
435 shift
436 done
438 if test -n "$init"
439 then
440 cmd_init "--" "$@" || return
443 cloned_modules=
444 module_list "$@" |
445 while read mode sha1 stage path
447 if test "$stage" = U
448 then
449 echo >&2 "Skipping unmerged submodule $path"
450 continue
452 name=$(module_name "$path") || exit
453 url=$(git config submodule."$name".url)
454 update_module=$(git config submodule."$name".update)
455 if test -z "$url"
456 then
457 # Only mention uninitialized submodules when its
458 # path have been specified
459 test "$#" != "0" &&
460 say "Submodule path '$path' not initialized" &&
461 say "Maybe you want to use 'update --init'?"
462 continue
465 if ! test -d "$path"/.git -o -f "$path"/.git
466 then
467 module_clone "$path" "$url" "$reference"|| exit
468 cloned_modules="$cloned_modules;$name"
469 subsha1=
470 else
471 subsha1=$(clear_local_git_env; cd "$path" &&
472 git rev-parse --verify HEAD) ||
473 die "Unable to find current revision in submodule path '$path'"
476 if ! test -z "$update"
477 then
478 update_module=$update
481 if test "$subsha1" != "$sha1"
482 then
483 force=
484 if test -z "$subsha1"
485 then
486 force="-f"
489 if test -z "$nofetch"
490 then
491 (clear_local_git_env; cd "$path" &&
492 git-fetch) ||
493 die "Unable to fetch in submodule path '$path'"
496 # Is this something we just cloned?
497 case ";$cloned_modules;" in
498 *";$name;"*)
499 # then there is no local change to integrate
500 update_module= ;;
501 esac
503 case "$update_module" in
504 rebase)
505 command="git rebase"
506 action="rebase"
507 msg="rebased onto"
509 merge)
510 command="git merge"
511 action="merge"
512 msg="merged in"
515 command="git checkout $force -q"
516 action="checkout"
517 msg="checked out"
519 esac
521 (clear_local_git_env; cd "$path" && $command "$sha1") ||
522 die "Unable to $action '$sha1' in submodule path '$path'"
523 say "Submodule path '$path': $msg '$sha1'"
526 if test -n "$recursive"
527 then
528 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
529 die "Failed to recurse into submodule path '$path'"
531 done
534 set_name_rev () {
535 revname=$( (
536 clear_local_git_env
537 cd "$1" && {
538 git describe "$2" 2>/dev/null ||
539 git describe --tags "$2" 2>/dev/null ||
540 git describe --contains "$2" 2>/dev/null ||
541 git describe --all --always "$2"
544 test -z "$revname" || revname=" ($revname)"
547 # Show commit summary for submodules in index or working tree
549 # If '--cached' is given, show summary between index and given commit,
550 # or between working tree and given commit
552 # $@ = [commit (default 'HEAD'),] requested paths (default all)
554 cmd_summary() {
555 summary_limit=-1
556 for_status=
557 diff_cmd=diff-index
559 # parse $args after "submodule ... summary".
560 while test $# -ne 0
562 case "$1" in
563 --cached)
564 cached="$1"
566 --files)
567 files="$1"
569 --for-status)
570 for_status="$1"
572 -n|--summary-limit)
573 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
574 then
576 else
577 usage
579 shift
582 shift
583 break
586 usage
589 break
591 esac
592 shift
593 done
595 test $summary_limit = 0 && return
597 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
598 then
599 head=$rev
600 test $# = 0 || shift
601 elif test -z "$1" -o "$1" = "HEAD"
602 then
603 # before the first commit: compare with an empty tree
604 head=$(git hash-object -w -t tree --stdin </dev/null)
605 test -z "$1" || shift
606 else
607 head="HEAD"
610 if [ -n "$files" ]
611 then
612 test -n "$cached" &&
613 die "--cached cannot be used with --files"
614 diff_cmd=diff-files
615 head=
618 cd_to_toplevel
619 # Get modified modules cared by user
620 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
621 sane_egrep '^:([0-7]* )?160000' |
622 while read mod_src mod_dst sha1_src sha1_dst status name
624 # Always show modules deleted or type-changed (blob<->module)
625 test $status = D -o $status = T && echo "$name" && continue
626 # Also show added or modified modules which are checked out
627 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
628 echo "$name"
629 done
632 test -z "$modules" && return
634 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
635 sane_egrep '^:([0-7]* )?160000' |
636 cut -c2- |
637 while read mod_src mod_dst sha1_src sha1_dst status name
639 if test -z "$cached" &&
640 test $sha1_dst = 0000000000000000000000000000000000000000
641 then
642 case "$mod_dst" in
643 160000)
644 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
646 100644 | 100755 | 120000)
647 sha1_dst=$(git hash-object $name)
649 000000)
650 ;; # removed
652 # unexpected type
653 echo >&2 "unexpected mode $mod_dst"
654 continue ;;
655 esac
657 missing_src=
658 missing_dst=
660 test $mod_src = 160000 &&
661 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
662 missing_src=t
664 test $mod_dst = 160000 &&
665 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
666 missing_dst=t
668 total_commits=
669 case "$missing_src,$missing_dst" in
671 errmsg=" Warn: $name doesn't contain commit $sha1_src"
674 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
676 t,t)
677 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
680 errmsg=
681 total_commits=$(
682 if test $mod_src = 160000 -a $mod_dst = 160000
683 then
684 range="$sha1_src...$sha1_dst"
685 elif test $mod_src = 160000
686 then
687 range=$sha1_src
688 else
689 range=$sha1_dst
691 GIT_DIR="$name/.git" \
692 git rev-list --first-parent $range -- | wc -l
694 total_commits=" ($(($total_commits + 0)))"
696 esac
698 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
699 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
700 if test $status = T
701 then
702 if test $mod_dst = 160000
703 then
704 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
705 else
706 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
708 else
709 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
711 if test -n "$errmsg"
712 then
713 # Don't give error msg for modification whose dst is not submodule
714 # i.e. deleted or changed to blob
715 test $mod_dst = 160000 && echo "$errmsg"
716 else
717 if test $mod_src = 160000 -a $mod_dst = 160000
718 then
719 limit=
720 test $summary_limit -gt 0 && limit="-$summary_limit"
721 GIT_DIR="$name/.git" \
722 git log $limit --pretty='format: %m %s' \
723 --first-parent $sha1_src...$sha1_dst
724 elif test $mod_dst = 160000
725 then
726 GIT_DIR="$name/.git" \
727 git log --pretty='format: > %s' -1 $sha1_dst
728 else
729 GIT_DIR="$name/.git" \
730 git log --pretty='format: < %s' -1 $sha1_src
732 echo
734 echo
735 done |
736 if test -n "$for_status"; then
737 if [ -n "$files" ]; then
738 echo "# Submodules changed but not updated:"
739 else
740 echo "# Submodule changes to be committed:"
742 echo "#"
743 sed -e 's|^|# |' -e 's|^# $|#|'
744 else
749 # List all submodules, prefixed with:
750 # - submodule not initialized
751 # + different revision checked out
753 # If --cached was specified the revision in the index will be printed
754 # instead of the currently checked out revision.
756 # $@ = requested paths (default to all)
758 cmd_status()
760 # parse $args after "submodule ... status".
761 orig_flags=
762 while test $# -ne 0
764 case "$1" in
765 -q|--quiet)
766 GIT_QUIET=1
768 --cached)
769 cached=1
771 --recursive)
772 recursive=1
775 shift
776 break
779 usage
782 break
784 esac
785 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
786 shift
787 done
789 module_list "$@" |
790 while read mode sha1 stage path
792 name=$(module_name "$path") || exit
793 url=$(git config submodule."$name".url)
794 displaypath="$prefix$path"
795 if test "$stage" = U
796 then
797 say "U$sha1 $displaypath"
798 continue
800 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
801 then
802 say "-$sha1 $displaypath"
803 continue;
805 set_name_rev "$path" "$sha1"
806 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
807 then
808 say " $sha1 $displaypath$revname"
809 else
810 if test -z "$cached"
811 then
812 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
813 set_name_rev "$path" "$sha1"
815 say "+$sha1 $displaypath$revname"
818 if test -n "$recursive"
819 then
821 prefix="$displaypath/"
822 clear_local_git_env
823 cd "$path" &&
824 eval cmd_status "$orig_args"
825 ) ||
826 die "Failed to recurse into submodule path '$path'"
828 done
831 # Sync remote urls for submodules
832 # This makes the value for remote.$remote.url match the value
833 # specified in .gitmodules.
835 cmd_sync()
837 while test $# -ne 0
839 case "$1" in
840 -q|--quiet)
841 GIT_QUIET=1
842 shift
845 shift
846 break
849 usage
852 break
854 esac
855 done
856 cd_to_toplevel
857 module_list "$@" |
858 while read mode sha1 stage path
860 name=$(module_name "$path")
861 url=$(git config -f .gitmodules --get submodule."$name".url)
863 # Possibly a url relative to parent
864 case "$url" in
865 ./*|../*)
866 url=$(resolve_relative_url "$url") || exit
868 esac
870 say "Synchronizing submodule url for '$name'"
871 git config submodule."$name".url "$url"
873 if test -e "$path"/.git
874 then
876 clear_local_git_env
877 cd "$path"
878 remote=$(get_default_remote)
879 git config remote."$remote".url "$url"
882 done
885 # This loop parses the command line arguments to find the
886 # subcommand name to dispatch. Parsing of the subcommand specific
887 # options are primarily done by the subcommand implementations.
888 # Subcommand specific options such as --branch and --cached are
889 # parsed here as well, for backward compatibility.
891 while test $# != 0 && test -z "$command"
893 case "$1" in
894 add | foreach | init | update | status | summary | sync)
895 command=$1
897 -q|--quiet)
898 GIT_QUIET=1
900 -b|--branch)
901 case "$2" in
903 usage
905 esac
906 branch="$2"; shift
908 --cached)
909 cached="$1"
912 break
915 usage
918 break
920 esac
921 shift
922 done
924 # No command word defaults to "status"
925 test -n "$command" || command=status
927 # "-b branch" is accepted only by "add"
928 if test -n "$branch" && test "$command" != add
929 then
930 usage
933 # "--cached" is accepted only by "status" and "summary"
934 if test -n "$cached" && test "$command" != status -a "$command" != summary
935 then
936 usage
939 "cmd_$command" "$@"